VST 3 Examples VST 3.7 SDK for developing VST plug-in

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Macros Groups Pages
Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
AGainWithSideChain Class Reference

`#include <againsidechain.h>`

Inheritance diagram for AGainWithSideChain:

## Public Member Functions
tresult | initialize (FUnknown *context) SMTG_OVERRIDE
tresult | process (ProcessData &data) SMTG_OVERRIDE
tresult | setBusArrangements (SpeakerArrangement *inputs, int32 numIns, SpeakerArrangement *outputs, int32 numOuts) SMTG_OVERRIDE
Public Member Functions inherited from AGain
| AGain ()
virtual | ~AGain ()
tresult | terminate () SMTG_OVERRIDE
| Called at the end before destructor.
tresult | setActive (TBool state) SMTG_OVERRIDE
| Switch the plug-in on/off.
tresult | receiveText (const char *text) SMTG_OVERRIDE
| Test of a communication channel between controller and component.
tresult | setState (IBStream *state) SMTG_OVERRIDE
| For persistence.
tresult | getState (IBStream *state) SMTG_OVERRIDE
tresult | setupProcessing (ProcessSetup &newSetup) SMTG_OVERRIDE
| Will be called before any process call.
tresult | canProcessSampleSize (int32 symbolicSampleSize) SMTG_OVERRIDE
| Asks if a given sample size is supported see SymbolicSampleSizes.
tresult | notify (IMessage *message) SMTG_OVERRIDE
| We want to receive message.
Public Member Functions inherited from AudioEffect
| AudioEffect ()
AudioBus * | addAudioInput (const TChar *name, SpeakerArrangement arr, BusType busType=kMain, int32 flags=BusInfo::kDefaultActive)
AudioBus * | addAudioOutput (const TChar *name, SpeakerArrangement arr, BusType busType=kMain, int32 flags=BusInfo::kDefaultActive)
AudioBus * | getAudioInput (int32 index)
AudioBus * | getAudioOutput (int32 index)
EventBus * | addEventInput (const TChar *name, int32 channels=16, BusType busType=kMain, int32 flags=BusInfo::kDefaultActive)
EventBus * | addEventOutput (const TChar *name, int32 channels=16, BusType busType=kMain, int32 flags=BusInfo::kDefaultActive)
EventBus * | getEventInput (int32 index)
EventBus * | getEventOutput (int32 index)
tresult | getBusArrangement (BusDirection dir, int32 busIndex, SpeakerArrangement &arr) SMTG_OVERRIDE
uint32 | getLatencySamples () SMTG_OVERRIDE
tresult | setProcessing (TBool state) SMTG_OVERRIDE
uint32 | getTailSamples () SMTG_OVERRIDE
uint32 | getProcessContextRequirements () SMTG_OVERRIDE
| Component ()
void | setControllerClass (const FUID &cid)
void | setControllerClass (const TUID &cid)
tresult | removeAudioBusses ()
tresult | removeEventBusses ()
tresult | renameBus (MediaType type, BusDirection dir, int32 index, const String128 newName)
tresult | getControllerClassId (TUID classID) SMTG_OVERRIDE
tresult | setIoMode (IoMode mode) SMTG_OVERRIDE
int32 | getBusCount (MediaType type, BusDirection dir) SMTG_OVERRIDE
tresult | getBusInfo (MediaType type, BusDirection dir, int32 index, BusInfo &info) SMTG_OVERRIDE
tresult | getRoutingInfo (RoutingInfo &inInfo, RoutingInfo &outInfo) SMTG_OVERRIDE
tresult | activateBus (MediaType type, BusDirection dir, int32 index, TBool state) SMTG_OVERRIDE
BusList * | getBusList (MediaType type, BusDirection dir)
tresult | removeAllBusses ()
| ComponentBase ()
| ~ComponentBase () override
FUnknown * | getHostContext () const
IConnectionPoint * | getPeer () const
IMessage * | allocateMessage () const
tresult | sendMessage (IMessage *message) const
tresult | sendTextMessage (const char8 *text) const
tresult | sendMessageID (const char8 *messageID) const
tresult | connect (IConnectionPoint *other) SMTG_OVERRIDE
tresult | disconnect (IConnectionPoint *other) SMTG_OVERRIDE

## Static Public Member Functions
static FUnknown * | createInstance (void *)
Static Public Member Functions inherited from AGain
static FUnknown * | createInstance (void *)

## Protected Member Functions
template<typename SampleType >
SampleType | processAudioWithSideChain (SampleType **in, SampleType **out, SampleType **aux, int32 numChannels, int32 sampleFrames, float gain)
Protected Member Functions inherited from AGain
template<typename SampleType >
SampleType | processAudio (SampleType **input, SampleType **output, int32 numChannels, int32 sampleFrames, float gain)
template<typename SampleType >
SampleType | processVuPPM (SampleType **input, int32 numChannels, int32 sampleFrames)

## Additional Inherited Members
Public Types inherited from IProcessContextRequirements
enum | Flags
Public Attributes inherited from AudioEffect
OBJ_METHODS(AudioEffect, Component) DEFINE_INTERFACES DEF_INTERFACE(IAudioProcessor) DEF_INTERFACE(IProcessContextRequirements) END_DEFINE_INTERFACES(Component) REFCOUNT_METHODS(Component) protected ProcessContextRequirements | processContextRequirements
OBJ_METHODS(Component, ComponentBase) DEFINE_INTERFACES DEF_INTERFACE(IComponent) END_DEFINE_INTERFACES(ComponentBase) REFCOUNT_METHODS(ComponentBase) protected BusList | audioInputs
BusList | audioOutputs
BusList | eventInputs
BusList | eventOutputs
OBJ_METHODS(ComponentBase, FObject) DEFINE_INTERFACES DEF_INTERFACE(IPluginBase) DEF_INTERFACE(IConnectionPoint) END_DEFINE_INTERFACES(FObject) REFCOUNT_METHODS(FObject) protected IPtr < IConnectionPoint > | peerConnection
Static Public Attributes inherited from IPluginBase
static const FUID | iid
Static Public Attributes inherited from IConnectionPoint
static const FUID | iid
Static Public Attributes inherited from IComponent
static const FUID | iid
Static Public Attributes inherited from IAudioProcessor
static const FUID | iid
Static Public Attributes inherited from IProcessContextRequirements
static const FUID | iid
Protected Attributes inherited from AGain
float | fGain
float | fGainReduction
float | fVuPPMOld
int32 | currentProcessMode
bool | bHalfGain {false}
bool | bBypass {false}

## Member Function Documentation

static FUnknown* createInstance | ( | void * |  | ) |
| inline static

tresult initialize | ( | FUnknown * | context | ) |
| virtual

Reimplemented from AGain.

tresult process | ( | ProcessData & | data | ) |
| virtual

Reimplemented from AGain.

tresult setBusArrangements | ( | SpeakerArrangement * | inputs,
|  | int32 | numIns,
|  | SpeakerArrangement * | outputs,
|  | int32 | numOuts
| ) |  |
| virtual

Reimplemented from AGain.

SampleType processAudioWithSideChain | ( | SampleType ** | in,
|  | SampleType ** | out,
|  | SampleType ** | aux,
|  | int32 | numChannels,
|  | int32 | sampleFrames,
|  | float | gain
| ) |  |
| protected

Empty

Copyright ©2022 Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.